Type to search.

Get data streams

  • GET /_data_stream/{name}
  • GET /_data_stream
Auth The Elastic Stack includes Elastic's core products such as Elasticsearch, Kibana, Logstash, and Beats. Availability Generally available since 7.9 This functionality is generally available and ready for production usage. Unless stated otherwise on the page, this functionality is available when your Elastic Stack is deployed on Elastic Cloud Hosted, Elastic Cloud Enterprise, Elastic Cloud on Kubernetes, and self-managed environments. This documentation corresponds to the latest patch available for each minor version. If you're not using the latest patch, check the release notes for changes.

Get information about one or more data streams.

Required privileges

Index privileges view_index_metadata

Path parameters

name union string | string[] optional

Comma-separated list of data stream names used to limit the request. Wildcard (*) expressions are supported. If omitted, all data streams are returned.

Leave it out to use /_data_stream.

Query parameters

expand_wildcards union oneOf · default: open

Type of data stream that wildcard patterns can match. Supports comma-separated values, such as open,hidden.

Supported values include:

  • all: Match any data stream or index, including hidden ones.
  • open: Match open, non-hidden indices. Also matches any non-hidden data stream.
  • closed: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
  • hidden: Match hidden data streams and hidden indices. Must be combined with open, closed, or both.
  • none: Wildcard expressions are not accepted.
Values: all open closed hidden none
include_defaults boolean · default: false The Elastic Stack includes Elastic's core products such as Elasticsearch, Kibana, Logstash, and Beats. Availability Generally available since 8.11 This functionality is generally available and ready for production usage. Unless stated otherwise on the page, this functionality is available when your Elastic Stack is deployed on Elastic Cloud Hosted, Elastic Cloud Enterprise, Elastic Cloud on Kubernetes, and self-managed environments. This documentation corresponds to the latest patch available for each minor version. If you're not using the latest patch, check the release notes for changes.

If true, returns all relevant default configurations for the index template.

master_timeout string · default: 30s

Period to wait for a connection to the master node. If no response is received before the timeout expires, the request fails and returns an error.

verbose boolean · default: false

Whether the maximum timestamp for each data stream should be calculated and returned.

Response

application/json
data_streams object[] required
_meta object

Custom metadata for the stream, copied from the _meta object of the stream’s matching index template. If empty, the response omits this property.

allow_custom_routing boolean

If true, the data stream allows custom routing on write request.

generation number required

Current generation for the data stream. This number acts as a cumulative count of the stream’s rollovers, starting at 1.

hidden boolean required

If true, the data stream is hidden.

ilm_policy string

Name of the current ILM lifecycle policy in the stream’s matching index template. This lifecycle policy is set in the index.lifecycle.name setting. If the template does not include a lifecycle policy, this property is not included in the response. NOTE: A data stream’s backing indices may be assigned different lifecycle policies. To retrieve the lifecycle policy for individual backing indices, use the get index settings API.

next_generation_managed_by enum required

Name of the lifecycle system that'll manage the next generation of the data stream.

Values: Index Lifecycle Management Data stream lifecycle Unmanaged
prefer_ilm boolean required

Indicates if ILM should take precedence over DSL in case both are configured to managed this data stream.

indices object[] required

Array of objects containing information about the data stream’s backing indices. The last item in this array contains information about the stream’s current write index.

index_name string required

Name of the backing index.

index_uuid string required

Universally unique identifier (UUID) for the index.

ilm_policy string

Name of the current ILM lifecycle policy configured for this backing index.

managed_by enum

Name of the lifecycle system that's currently managing this backing index.

Values: Index Lifecycle Management Data stream lifecycle Unmanaged
prefer_ilm boolean

Indicates if ILM should take precedence over DSL in case both are configured to manage this index.

index_mode enum

The index mode of this backing index of the data stream.

Values: standard time_series logsdb lookup
name string required

Name of the data stream.

replicated boolean

If true, the data stream is created and managed by cross-cluster replication and the local cluster can not write into this data stream or change its mappings.

rollover_on_write boolean required

If true, the next write to this data stream will trigger a rollover first and the document will be indexed in the new backing index. If the rollover fails the indexing request will fail too.

settings object required

The settings specific to this data stream that will take precedence over the settings in the matching index template.

status enum required

Health status of the data stream. This health status is based on the state of the primary and replica shards of the stream’s backing indices.

Supported values include:

  • green (or GREEN): All shards are assigned.
  • yellow (or YELLOW): All primary shards are assigned, but one or more replica shards are unassigned. If a node in the cluster fails, some data could be unavailable until that node is repaired.
  • red (or RED): One or more primary shards are unassigned, so some data is unavailable. This can occur briefly during cluster startup as primary shards are assigned.
  • unknown
  • unavailable
Values: green GREEN yellow YELLOW red RED unknown unavailable
system boolean The Elastic Stack includes Elastic's core products such as Elasticsearch, Kibana, Logstash, and Beats. Availability Generally available since 7.10 This functionality is generally available and ready for production usage. Unless stated otherwise on the page, this functionality is available when your Elastic Stack is deployed on Elastic Cloud Hosted, Elastic Cloud Enterprise, Elastic Cloud on Kubernetes, and self-managed environments. This documentation corresponds to the latest patch available for each minor version. If you're not using the latest patch, check the release notes for changes.

If true, the data stream is created and managed by an Elastic stack component and cannot be modified through normal user interaction.

template string required

Name of the index template used to create the data stream’s backing indices. The template’s index pattern must match the name of this data stream.

timestamp_field object required

Information about the @timestamp field in the data stream.

name string required

Name of the timestamp field for the data stream, which must be @timestamp. The @timestamp field must be included in every document indexed to the data stream.

index_mode enum

The index mode for the data stream that will be used for newly created backing indices.

Values: standard time_series logsdb lookup